/*
 * Copyright 2000 Perforce Software.  All rights reserved.
 *
 * This file is part of Perforce - the FAST SCM System.
 */

/*
 * FstatHelper - Utility to facilitate synchronous access to
 * the server to get fstat information.
 *
 * Public methods:
 *
 *	FstatHelper::FstatHelper() - constructor takes: a file path, a ClientApi
 *                                   to perform the commands with
 *	FstatHelper::GetLocalPath() - get the local path in the client workspace
 *                                    this returns the path to the file on the
 *                                    local drive.
 *
 */

class FstatHelper : public ClientUser {

    public:
	FstatHelper( StrPtr & path, ClientApi & );
	~FstatHelper();
	StrPtr * GetLocalPath();
	FileSys * GetLocalFile();
	FileSysType GetFileType();
	StrPtr * GetAction();
	int IsTextFile();
	int FileTypeUnknown();

    private:

	ClientApi * api;
	StrPtr pathSpec;
	
	StrDict * results;
	
	virtual void	OutputStat( StrDict *varList );
	virtual void	Finished() {};
	virtual void	HandleError( Error *e ) {};
	
	StrDict *	GetResults();
	FileSys *	fileSys;
} ;

